import urllib2
import re
import websocket
import json

import Image
import ImageDraw
import ImageFont

import Adafruit_ILI9341 as TFT
import Adafruit_GPIO as GPIO
import Adafruit_GPIO.SPI as SPI

# pin configuration.
DC = 18
RST = 23
SPI_PORT = 0
SPI_DEVICE = 0

# display class.
disp = TFT.ILI9341(DC, rst=RST, spi=SPI.SpiDev(SPI_PORT, SPI_DEVICE, max_speed_hz=64000000))

# initialize display.
disp.begin()
disp.clear()
draw = disp.draw()

# load a TTF font. http://www.dafont.com/de/keep-calm.font
font_big = ImageFont.truetype('KeepCalm-Medium.ttf', 100)
font_small = ImageFont.truetype('KeepCalm-Medium.ttf', 18)

# text function
def draw_rotated_text(image, text, position, font, fill=(255,255,255)):
        x, y = position
        # get rendered font dimensions.
        draw = ImageDraw.Draw(image)
        width, height = draw.textsize(text, font=font)
        #center text
        x-=(width/2)
        # create a new image to store the text.
        textimage = Image.new('RGBA', (width, height), (0,0,0,0))
        textdraw = ImageDraw.Draw(textimage)
        textdraw.text((0,0), text, font=font, fill=fill)
        # paste the text into the image, using it as a mask for transparency.
        image.paste(textimage, (x,y), textimage)

# get the websocket url
user_agent = 'Mozilla/5.0 (RaspberryPI; en-US) zeflo/2015 (python script)'
headers = { 'User-Agent' : user_agent }
req = urllib2.Request('http://www.reddit.com/r/thebutton', None, headers)
response = urllib2.urlopen(req)
page = response.read()
found = re.search('wss://(.+?)"', page)

# if successfull
if found:
        url = "wss://" + found.group(1)
        print url
        from websocket import create_connection
        #connect
        ws = create_connection(url)
        fewest = 60
        while 1:
                result =  ws.recv()
                result = json.loads(result)
                seconds_left = int(result['payload']['seconds_left'])
                participants = result['payload']['participants_text']
                if seconds_left < fewest:
                        fewest = seconds_left
                disp.clear()
                # write text.
                draw_rotated_text(disp.buffer, str(seconds_left), (120, 50), font_big, fill=(255,255,255))
                draw_rotated_text(disp.buffer, participants+' participants', (120, 220), font_small, fill=(180,180,180))
                draw_rotated_text(disp.buffer, 'record: '+str(fewest)+'s', (120, 260), font_small, fill=(180,180,180))
                # write buffer to display hardware
                disp.display()
        ws.close()
                                           